diff --git a/pgweb/util/contexts.py b/pgweb/util/contexts.py
index 35dc384a..b66d41cb 100644
--- a/pgweb/util/contexts.py
+++ b/pgweb/util/contexts.py
@@ -49,6 +49,7 @@ sitenav = {
         {'title': 'IRC', 'link': '/community/irc/'},
         # {'title': 'Slack', 'link': 'https://join.slack.com/t/postgresteam/shared_invite/zt-1qj14i9sj-E9WqIFlvcOiHsEk2yFEMjA'},
         {'title': 'Local User Groups', 'link': '/community/user-groups/'},
+        {'title': 'Recognised NPOs', 'link': '/community/recognised-npos/'},
         {'title': 'Events', 'link': '/about/events/'},
         {'title': 'International Sites', 'link': '/community/international/'},
     ],
diff --git a/templates/pages/about/donate.html b/templates/pages/about/donate.html
index 9a4214b6..e7f51c3f 100644
--- a/templates/pages/about/donate.html
+++ b/templates/pages/about/donate.html
@@ -4,6 +4,17 @@
 
 <h1>Donate <i class="far fa-money-bill-alt"></i></h1>
 
+<p>
+    This pages lists <a href="/community/recognised-npos">Recognised NPOs</a>
+    and additional non-profit organisations that are critical to the PostgreSQL
+    project. Donations to these organizations are helpful in
+    supporting our work.
+</p>
+<p>
+    For larger donations, please consider becoming a <a
+    href="/about/financial/">Financial Sponsor</a>.
+</p>
+
 <h2>PostgreSQL Project assets</h2>
 <p>
   The <a href="https://postgres.ca">PostgreSQL Community Association</a>
@@ -37,8 +48,8 @@ refer to the party you are donating to and your tax professional.</p>
 
 <h2>PostgreSQL Nonprofit Organisation (NPO) Recognition</h2>
 <p>For information about how <a href="/about/policies/npos/">Recognised PostgreSQL Nonprofit Organisations
-  (NPOs)</a> become recognised, please review the guidelines <a href="/about/policies/npos/">here</a>.</p>
-
+        (NPOs)</a> become recognised, please review the guidelines <a href="/about/policies/npos/">here</a>.</p>
+        
 <h2>Questions</h2>
 <p>If you have any questions about donations please contact either the
 <a href="mailto:funds-group@postgresql.org">PostgreSQL Funds Group</a> or the
diff --git a/templates/pages/about/policies/npos.html b/templates/pages/about/policies/npos.html
index 5b1ff07a..3d75bf71 100644
--- a/templates/pages/about/policies/npos.html
+++ b/templates/pages/about/policies/npos.html
@@ -5,9 +5,9 @@
 
 <h1>Recognised PostgreSQL Nonprofit Organisations <i class="fas fa-gavel"></i></h1>
 
-<p><em>Last updated: July 29, 2017. {%git_changes_link%} <a href="https://git.postgresql.org/gitweb/?p=pgweb.git;a=history;f=templates/pages/community/recognition.html">View</a> history before December 8, 2020.</em></p>
+<p><em>Last updated: December 19, 2024. {%git_changes_link%} <a href="https://git.postgresql.org/gitweb/?p=pgweb.git;a=history;f=templates/pages/community/recognition.html">View</a> history before December 8, 2020.</em></p>
 
-<p>Recognised PostgreSQL Nonprofit Organisations (NPOs) will be listed on the <a href="/">PostgreSQL Website</a> as such. To become recognised as an NPO, the organisation must self-certify that they meet the criteria below, aimed at ensuring they meet the standards of openness expected in the PostgreSQL Community.
+<p>Recognised PostgreSQL Nonprofit Organisations (NPOs) will be listed on the <a href="/community/recognised-npos/">PostgreSQL Website</a> as such. To become recognised as an NPO, the organisation must self-certify that they meet the criteria below, aimed at ensuring they meet the standards of openness expected in the PostgreSQL Community.
 </p>
 <p>
   Use of the terms "MUST", "MUST NOT", "SHOULD" and "SHOULD NOT" in the criteria below should be interpreted per <a href="https://www.ietf.org/rfc/rfc2119.txt" target="_blank" rel="noopener">RFC2119</a>.
diff --git a/templates/pages/community/recognised-npos.html b/templates/pages/community/recognised-npos.html
new file mode 100644
index 00000000..d092d09a
--- /dev/null
+++ b/templates/pages/community/recognised-npos.html
@@ -0,0 +1,42 @@
+{%extends "base/page.html"%}
+{%block title%}Recognised NPOs{%endblock%}
+{%block contents%}
+
+<h1>Recognised NPOs</h1>
+
+<p>Recognised NPOs (Non Profit Organisations) are legal entities that support
+    the PostgreSQL project as their primary objective, and are managed in
+    accordance with the <a href="/about/policies/npos/">Recognised PostgreSQL
+    Nonprofit Organisations</a> policy.</p>
+
+<h2>PostgreSQL Europe</h2>
+
+<p>PostgreSQL Europe is the "umbrella group" for PostgreSQL User Groups in
+    Europe and for users in regions that don't have a local user group. It's
+    goal is to promote the use of PostgreSQL in Europe, primarily by assisting
+    local user groups to promote the product locally through conferences and
+    other advocacy, as well as running European-wide conferences and other
+    activities.</p>
+<p>More information can be found on the
+    <a href="https://www.postgresql.eu/">PostgreSQL Europe website</a>.</p>
+
+<h2>PostgreSQLFr</h2>
+
+<p>PostgreSQLFr has as its objectives the promotion, the support for
+    deployment and the development of the Open Source software PostgreSQL
+    and its derivatives and related projects in France and in French
+    speaking countries.</p>
+<p>PostgreSQLFr organises the "PG Day France" each year in a different
+    city, since 2008.</p>
+<p>More information can be found on the
+    <a href="https://www.postgresql.fr/">PostgreSQLFr website</a>.</p>
+
+<h2>United States PostgreSQL Association</h2>
+
+<p>The United States PostgreSQL Association, affectionately known as PgUS,
+    is a IRS 501(c)(3) public charity. It's purpose is to support the growth
+    and education of PostgreSQL, The World's Most Advanced Open Source 
+    Database.</p>
+<p>More information can be found on the
+    <a href="https://postgresql.us/">PgUS website</a>.</p>
+{%endblock%}